<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 68</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome Icons -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>

<body class="hold-transition sidebar-mini">

    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Home</a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Devcamp 120</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user panel (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Hồ Bá TRường</a>
                    </div>
                </div>


                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Starter Pages
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Voucher.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Voucher list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="CMenu.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    CMenu list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="CDrink.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    CDrink list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="Country.html" class="nav-link ">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    Country list
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="User.html" class="nav-link active">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    User list
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h2>DANH SÁCH USER</h2>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">User list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <div class="content">
                <div class="container-fluid">
                    <div class="row">
                        <button class="btn btn-primary" id="btn-create"><i class="fa-solid fa-plus"></i> &nbsp; Create
                            User</button>
                        <div class="col-12">
                            <table class="table table-bordered table-striped table-hover" id="user-table">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Full name</th>
                                        <th>Email</th>
                                        <th>Phone</th>
                                        <th>Address</th>
                                        <th>Ngày tạo</th>
                                        <th>Ngày cập nhật</th>
                                        <th>Action</th>
                                        <th>Danh sách Order</th>
                                    </tr>
                            </table>
                            <!-- Vùng Modal -->
                            <!-- Create Order modal -->
                            <div>
                                <div id="create-user-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Create user
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Full name</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-fullname"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Email</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-email"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Phone</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-phone"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Address</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-address"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-create-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-create-user">Create
                                                    user</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Update Order modal -->
                            <div>
                                <div id="update-user-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Update Trạng Thái user
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Full name</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-fullname"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Email</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-email"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Phone</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-phone"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Address</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-address"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-update-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-update-user">Update Trạng
                                                    Thái</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Delete confirm modal -->
                            <div>
                                <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <label>Bạn có chắc chắn muốn xóa user này không?</label>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-danger"
                                                    id="btn-confirm-delete-user">Confirm</button>
                                                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <!-- Order Detail modal -->
                            <div>

                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content -->
        </div>
        <!-- Main Footer -->
        <footer class="main-footer">
            <!-- To the right -->
            <div class="float-right d-none d-sm-inline">
                DANH SÁCH ĐƠN HÀNG
            </div>
            <!-- Default to the left -->
            <strong>Copyright &copy; 2023 Devcamp 120.</strong> All rights
            reserved.
        </footer>
    </div>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script>
        "use strict";
        $(document).ready(function () {
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "http://localhost:8080/user/";

            const gCOLUMN_ID = 0;
            const gCOLUMN_FULLNAME = 1;
            const gCOLUMN_EMAIL = 2;
            const gCOLUMN_PHONE = 3;
            const gCOLUMN_ADDRESS = 4;
            const gCOLUMN_NGAY_TAO = 5;
            const gCOLUMN_NGAY_CAP_NHAT = 6;
            const gCOLUMN_ACTION = 7;
            const gCOLUMN_DS_ORDER = 8;

            const gCOLUMN = ["id", "fullname", "email", "phone", "address", "created", "updated", "action", "dsorders"];

            var gUser_code = {
                id: "",
            }
            // định nghĩa table  - chưa có data
            var guserTable = $("#user-table").DataTable({
                // Khai báo các cột của datatable
                "columns": [
                    { "data": gCOLUMN[gCOLUMN_ID] },
                    { "data": gCOLUMN[gCOLUMN_FULLNAME] },
                    { "data": gCOLUMN[gCOLUMN_EMAIL] },
                    { "data": gCOLUMN[gCOLUMN_PHONE] },
                    { "data": gCOLUMN[gCOLUMN_ADDRESS] },
                    { "data": gCOLUMN[gCOLUMN_NGAY_TAO] },
                    { "data": gCOLUMN[gCOLUMN_NGAY_CAP_NHAT] },
                    { "data": gCOLUMN[gCOLUMN_ACTION] },
                    { "data": gCOLUMN[gCOLUMN_DS_ORDER] }
                ],
                // Ghi đè nội dung của cột action, chuyển thành button chi tiết
                "columnDefs": [
                    {
                        "targets": gCOLUMN_ACTION,
                        "defaultContent": '<i class="fas fa-pen text-info edit-user"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-user"></i>'
                    },
                    {
                        "targets": gCOLUMN_DS_ORDER,
                        "defaultContent": '<button class="btn btn-primary order-user">Danh sách Order</button>'
                    }
                ]
            });

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#btn-create").on("click", function () {
                $("#create-user-modal").modal("show");
            });
            $("#btn-create-user").on("click", function () {
                onCreateuser();
            });
            $("#user-table").on("click", ".edit-user", function () {
                onButtonChiTietClick(this); // this là button được ấn
            });
            // khi ấn nút sự kiện update trên modal
            $("#btn-update-user").on("click", function () {
                onBtnUpdateClick();
            });
            // khi ấn sự kiện delete
            $("#user-table").on("click", ".delete-user", function () {
                onBtnDeleteConfirmOrderClick(this);
            });
            // gán sự kiện cho nút Delete  (trên modal)
            $("#btn-confirm-delete-user").on("click", function () {
                onBtnDeleteuserClick();
            });
            $("#user-table").on("click", ".order-user", function () {
                onBtnToOrderClick(this);
            });
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            // Hàm sự kiện thêm user
            function onCreateuser() {
                // khai báo dữ liệu
                var vUserObj = {
                    fullname: "",
                    email: "",
                    phone: "",
                    address: ""
                }
                // thu thập thông tin 
                getCreateData(vUserObj);
                // validate
                if (kiemtraCreateData(vUserObj)) {
                    // Tạo mới order
                    createuser(vUserObj);
                }
            }
            // hàm thu thập thông tin để create order
            function getCreateData(paramObj) {
                paramObj.fullname = $("#input-create-fullname").val();
                paramObj.email = $("#input-create-email").val();
                paramObj.phone = $("#input-create-phone").val();
                paramObj.address = $("#input-create-address").val();
            }
            function kiemtraCreateData(paramObj) {
                if (paramObj.fullname == "") {
                    alert("Bạn điền fullname không hợp lệ")
                    return false;
                }
                if (paramObj.email == "") {
                    alert("Bạn điền email không hợp lệ")
                    return false;
                }
                if (paramObj.phone == "") {
                    alert("Bạn điền phone không hợp lệ")
                    return false;
                }
                if (paramObj.address == "") {
                    alert("Bạn điền address không hợp lệ")
                    return false;
                }
                return true;
            }
            //Hàm tạo đơn mói
            function createuser(paramObj) {
                $.ajax({
                    url: gBASE_URL + "create",
                    type: 'POST',
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (paramObjuser) {
                        //hiển thị dữ liệu lên web
                        console.log(paramObjuser);
                        onPageLoading();
                        $("#create-user-modal").modal("hide");
                        alert("Bạn tạo thành công user");
                        $("#input-create-fullname").val("");
                        $("#input-create-email").val("");
                        $("#input-create-phone").val("");
                        $("#input-create-address").val("");
                    },
                    error: function (error) {
                        alert("Bạn tạo Đơn user thất bại!");
                        console.log(error.responseText)
                    }
                });
            }
            // infoFunction sẽ là function các nút cùng gọi
            function onButtonChiTietClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = guserTable.row(vRowSelected);
                //Lấy data của dòng 
                var vuserData = vDatatableRow.data();
                gUser_code.id = vuserData.id;
                // lấy api để load vào modal
                getuserbyuserID();
                $("#update-user-modal").modal("show");
            }
            function getuserbyuserID() {
                $.ajax({
                    url: "http://localhost:8080/user/details/" + gUser_code.id,
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToModal(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm load data to modal update
            function loadDataToModal(paramResponseObject) {
                $("#input-update-fullname").val(paramResponseObject.fullname);
                $("#input-update-email").val(paramResponseObject.email);
                $("#input-update-phone").val(paramResponseObject.phone);
                $("#input-update-address").val(paramResponseObject.address);
            }
            function onPageLoading() {
                //Khai báo dữ liệu
                //validate
                // lấy data từ server
                getAlluserbyapi();
                // Xử lý front-end
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            function getAlluserbyapi() {
                $.ajax({
                    url: gBASE_URL + "all",
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToTable(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // load data to table
            function loadDataToTable(paramResponseObject) {
                //Xóa toàn bộ dữ liệu đang có của bảng
                guserTable.clear();
                //Cập nhật data cho bảng 
                guserTable.rows.add(paramResponseObject);
                //Cập nhật lại giao diện hiển thị bảng
                guserTable.draw();
            }
            // khi bấm nút Update trên modal
            function onBtnUpdateClick() {
                console.log(gUser_code.id);
                //khai báo dữ liệu
                var vObjectRequest = {
                    fullname: "",
                    email: "",
                    phone: "",
                    address: ""
                }
                // gán dữ liệu
                vObjectRequest.fullname = $("#input-update-fullname").val();
                vObjectRequest.email = $("#input-update-email").val();
                vObjectRequest.phone = $("#input-update-phone").val();
                vObjectRequest.address = $("#input-update-address").val();
                //validate
                var validate = kiemtraCreateData(vObjectRequest);
                if (validate) {
                    //cập nhật trạng thái
                    updateUser(vObjectRequest);
                }
            }
            //update user
            function updateUser(paramObj) {
                $.ajax({
                    url: gBASE_URL + "update/" + gUser_code.id,
                    type: "PUT",
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        handleUpdatetSuccess(responseObject.id);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm xử lý sự kiện delete order modal click
            function onBtnDeleteuserClick() {
                //khai báo dữ liệu
                //validate
                //gọi api
                $.ajax({
                    url: gBASE_URL + "delete/" + gUser_code.id,
                    type: "DELETE",
                    contentType: "application/json; charset=utf-8",
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleDeleteuserSuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
                //hiển thị thông tin
            }
            // hàm xử lý hiển thị front-end khi update Trạng thái thành công
            function handleUpdatetSuccess(paramObj) {
                onPageLoading();
                alert("Update user Id = " + paramObj + " thành công!");
                $("#update-user-modal").modal("hide");
            }
            // hàm xử lý hiển thị front-end khi sửa user thành công
            function handleDeleteuserSuccess() {
                onPageLoading();
                alert("Xóa user thành công!");
                $("#delete-confirm-modal").modal("hide");
            }
            function onBtnDeleteConfirmOrderClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = guserTable.row(vRowSelected);
                //Lấy data của dòng 
                var vuserData = vDatatableRow.data();
                gUser_code.id = vuserData.id;
                // lấy api để load vào modal
                $("#delete-confirm-modal").modal("show");
            }
            function onBtnToOrderClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = guserTable.row(vRowSelected);
                //Lấy data của dòng 
                var vOrderData = vDatatableRow.data();
                gUser_code.id = vOrderData.id;
                // location trang mới
                var vUrlSiteToOpen = "Order.html" +
                    "?id=" + gUser_code.id;
                window.location.href = vUrlSiteToOpen;

            }
        });
    </script>
</body>

</html>